<?php
namespace Folha\Logic\ESocial;

/**
 * undocumented class
 *
 * @package default
 * @author 
 **/
class PreVisualizacao
{

    private $eventos;
    private $raiz;

    public function __construct($diretorioRaiz) {
        $this->eventos = array();
        $this->raiz    = $diretorioRaiz;
    }

    public function getDadosEmArvore() 
    {
        $eventos = $this->getEventos($this->raiz);
        $this->getArquivosEventos($this->raiz);
        foreach ($this->eventos as $evento) {
            $xml = file_get_contents($evento);
            $xml = new \SimpleXMLElement($xml);
            
            $nomeDiretorio = explode("/", $evento);
            $nomeArquivo   = $nomeDiretorio[count($nomeDiretorio) - 1];
            $nomeDiretorio = $nomeDiretorio[count($nomeDiretorio) - 2];
            foreach ($eventos as &$value) {
                if ($value["title"] === $nomeDiretorio) {
                    $data = $this->processData($xml);
                    $value["children"][] = array(
                        "title"    => $nomeArquivo,
                        "children" =>  $data,
                    );
                }
            }
        }
        return $eventos;
    }

    private function processData(\SimpleXMLElement $xml) 
    {
        $xml = (array)$xml;
        $array = array();
        foreach ($xml as $key => $value) {
            $aux = array();
            $aux["title"] = $key;
            if (is_array($value) || is_object($value)) {
                $aux["children"] = $this->processdata($value);
            } else {
                $aux["children"] = array("title" => $value);
            }

            $array[] = $aux;
        }

        return $array;
    }

    private function getEventos($raiz) 
    {
        $eventos = array();
        foreach (glob($raiz."/*") as $value) {
            $nomeDiretorio = explode("/", $value);
            $nomeDiretorio = $nomeDiretorio[count($nomeDiretorio) - 1];

            $eventos[] = array(
                "title"    => $nomeDiretorio,
                "isFolder" => true,
                "children" => array(),
            );
        }

        return $eventos;
    }

    private function getArquivosEventos($raiz) 
    {
        foreach (glob($raiz."/*") as $value) {
            if (is_dir($value)) {
                $this->getArquivosEventos($value);
            } else {
                $this->eventos[] = $value;
            }
        }
    }

    /**
     * Gera a forma de visualização de cada evento de acordo com seus dados
     *
     * @param $nmEvento     Nome do evento que está sendo gerado
     * @param $item         Dados do evento que está sendo gerado
     *
     * @return array    Retorna os dados do evento organizados para visualização
     */
    public function geraVisualizacaoItemEvento($nmEvento, $item)
    {
        switch ($nmEvento) {
            /*Eventos Iniciais*****************************************************************************************/
            case 'S-1000':
                $dsEvento = "Informações do Empregador/Contribuinte";
                $id = $this->Mask("##.###.###/####-##", $item['NRINSCRICAO']);
                $dados = "Razão Social:" . $item['NOMERAZAO'];
                break;
            case 'S-1060':
                $dsEvento = "Tabela de Estabelecimentos e Obras de Construção Civil";
                $id = $this->Mask("##.###.###/####-##", $item['ESTABNRINSCRICAO']);
                $dados = "Fpas:" . $item['FPAS'] . ", Cod. Terceiros:" . $item['CODTERCEIROS'] . ", CNAE:" . $item['CNAEPREPONDERANTE'];
                break;
            case 'S-2100':
                $dsEvento = "Cadastramento Inicial do Vínculo";
                $id = $item['NOMETRAB'];
                $dados = "CPF:" . $this->Mask("###.###.###-##", $item['CPFTRAB']) . ", Matrícula:" . $item['MATRICULA'] . ", Admissão:" . $this->Mask("##/##/####", $item['DTADMISSAO']) . ", Regime:" . $item['TPREGIMETRAB'] . ", Cargo:" . $item['CODCARGO'];
                break;
            /*Eventos de Tabela****************************************************************************************/
            case 'S-1010':
                $dsEvento = "Tabela de Rubricas";
                $id = $item['DESCRUBRICA'];
                $dados = "Rubrica:" . $item['CODRUBRICA'] . "-" . $item['DESCRUBRICA'] . ", Natureza:" . $item['NATRUBRICA'] . ", Provento/Desconto:" . $item['INDPROVDESC'];
                break;
            case 'S-1020':
                $dsEvento = "Tabela de Lotações";
                $id = $item['NRINSCESTAB'];
                $dados = "Lotação:" . $item['CODLOTACAO'] . "-" . $item['DESCLOTACAO'] . ", Tipo:" . $item['TPLOTACAO'] . ", FPAS:" . $item['FPAS'] . ", Cod. Terceiros:" . $item['CODTERCEIROS'];
                break;
            case 'S-1030':
                $dsEvento = "Tabela de Cargos";
                $id = $item['DESCCARGO'];
                $dados = "Cargo:" . $item['CODCARGO'] . "-" . $item['DESCCARGO'];
                break;
            case 'S-1040':
                $dsEvento = "Tabela de Funções";
                $id = $item['DESCFUNCAO'];
                $dados = "Função:" . $item['CODFUNCAO'] . "-" . $item['DESCFUNCAO'];
                break;
            case 'S-1050':
                $dsEvento = "Tabela de Horários/Turnos de Trabalho";
                $id = "Horário:" . $item['CODHORCONTRATUAL'];
                $dados = "Entrada:" . $item['HORAENTRADA'] . ", Saída:" . $item['HORASAIDA'] . ", Jornada(min):" . $item['DURJORNADA'] .
                    ", Intervalo:" . $item['DURINTERVALO'] . "(Início:" . $item['INICIOINTERVALO'] . " Término:" . $item['TERMINOINTERVALO'] . ")";
                break;
            /*Eventos Não-Periódicos***********************************************************************************/
            case 'S-2200':
                $dsEvento = "Admissão de Trabalhador";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                //$dados = "Matrícula:" . $item['MATRICULA'] . ", Admissão:" . $this->Mask("##/##/####", $item['DTADMISSAO']) . ", Regime:" . $item['TPREGIMETRAB'] . ", Cargo:" . $item['CODCARGO'];
                $dados = "Matrícula:" . $item['MATRICULA'] . ", Nome:" . $item['NOMETRAB'] . ", Regime:" . $item['TPREGIMETRAB'] . ", Cargo:" . $item['CODCARGO'];
                break;
            case 'S-2220':
                $dsEvento = "Alteração de Dados Cadastrais do Trabalhador";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Matrícula:" . $item['MATRICULA'] . ", Admissão:" . $this->Mask("##/##/####", $item['DTADMISSAO']) . ", Regime:" . $item['TPREGIMETRAB'] . ", Cargo:" . $item['CODCARGO'];
                break;
            case 'S-2240':
                $dsEvento = "Alteração de Contrato de Trabalho";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Matrícula:" . $item['MATRICULA'] . ", Admissão:" . $this->Mask("##/##/####", $item['DTADMISSAO']) . ", Regime:" . $item['TPREGIMETRAB'] . ", Cargo:" . $item['CODCARGO'];
                break;
            case 'S-2260':
                $dsEvento = "Comunicação de Acidente de Trabalho";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Data:" . $this->Mask("##/##/####", $item['DTACIDENTE']) . " Hora:" . $item['HORAACIDENTE'] . " Tipo:" . $item['TPACIDENTE'] . " Local:" . $item['DESCLOCAL'];
                break;
            case 'S-2320':
                $dsEvento = "Afastamento Temporário";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Data:" . $this->Mask("##/##/####", $item['DTAFASTAMENTO']) . " Motivo:" . $item['CODMOTAFASTAMENTO'] . " CID:" . $item['CODCID'] . " Dias:" . $item['QTDDIASAFASTAMENTO'];
                break;
            case 'S-2330':
                $dsEvento = "Retorno de Afastamento Temporário";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Data:" . $this->Mask("##/##/####", $item['DTAFASTAMENTO']) . " Motivo:" . $item['CODMOTAFASTAMENTO'] . " CID:" . $item['CODCID'] . " Dias:" . $item['QTDDIASAFASTAMENTO'];
                break;
            case 'S-2340':
                $dsEvento = "Estabilidade – Início";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Início:" . $this->Mask("##/##/####", $item['DTINIESTABILIDADE']) . " Motivo:" . $item['CODMOTIVOESTABILIDADE'];
                break;
            case 'S-2345':
                $dsEvento = "Estabilidade – Término";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Fim:" . $this->Mask("##/##/####", $item['DTINIESTABILIDADE']) . " Motivo:" . $item['CODMOTIVOESTABILIDADE'];
                break;
            case 'S-2400':
                $dsEvento = "Aviso Prévio";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Data:" . $this->Mask("##/##/####", $item['DTAVISOPREVIO']) . " Desligamento:" . $this->Mask("##/##/####", $item['DTPREVDESLIGAMENTO']) . " Tipo:" . $item['TPAVISOPREVIO'];
                break;
            case 'S-2600':
                $dsEvento = "Trabalhador Sem Vínculo de Emprego - Início";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Trabalhador Sem Vínculo:" . $item['NOMETRAB'];
                break;
            case 'S-2620':
                $dsEvento = "Trabalhador Sem Vínculo de Emprego - Alt. Contratual";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Trabalhador Sem Vínculo:" . $item['NOMETRAB'];
                break;
            case 'S-2640':
                $dsEvento = "Trabalhador Sem Vínculo de Emprego - Término";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Trabalhador Sem Vínculo:" . $item['NOMETRAB'];
                break;
            case 'S-2800':
                $dsEvento = "Desligamento";
                $id = $this->Mask("###.###.###-##", $item['CPFTRAB']);
                $dados = "Matrícula:" . $item['MATRICULA'] . " Motivo:" . $item['MOTIVODESLIGAMENTO'] . " Data:" . $this->Mask("##/##/####", $item['DTDESLIGAMENTO']) . " Aviso Prévio:" . $item['INDPAGTOAPI'] . " Valor:" . $item['VLRLIQUIDO'];
                break;
            /*Eventos Periódicos***************************************************************************************/
            case 'S-1100':
                $dsEvento = "Abertura";
                $id = $item['PERAPURACAO'];
                $dados = "Responsável:" . $item['NOMERESPONSAVEL'] . " CPF:" . $item['CPFRESPONSAVEL'];
                break;
            case 'S-1200':
                $dsEvento = "Remuneração do Trabalhador";
                $id = $item['PERAPURACAO'];
                $dados = "CPF:" . $this->Mask("###.###.###-##", $item['CPFTRAB']) . " Matrícula:" . $item['MATRICULA'] .
                    " Proventos:R$" . number_format($item['VLRPROVENTOS'], 2, ',', '.') .
                    " Descontos:R$" . number_format($item['VLRDESCONTOS'], 2, ',', '.') .
                    " Líquido:R$" . number_format($item['VLRLIQUIDO'], 2, ',', '.');
                break;

            case 'S-1399':
                $dsEvento = "Fechamento";
                $id = $item['PERAPURACAO'];
                $dados = "S-1200:" . $item['EVTREMUNERACAO'] .
                    " S-1300:" . $item['EVTPAGAMENTOSDIVERSOS'] .
                    " S-1310:" . $item['EVTSERVTOMADOSCMO'] .
                    " S-1320:" . $item['EVTSERVPRESTADOSCMO'] .
                    " S-1330:" . $item['EVTSERVTOMADOSCOOP'] .
                    " S-1340:" . $item['EVTSERVPRESTADOSCOOP'] .
                    " S-1350:" . $item['EVTAQUISPRODRURAL'] .
                    " S-1360:" . $item['EVTCOMERCPRODUCAO'] .
                    " S-1370:" . $item['EVTREPASSECLUBEFUTEBOL'] .
                    " S-1380:" . $item['EVTINFODESONERACAO'] .
                    " S-1390:" . $item['EVTRECEITAATIVCONCOMITANTES'];
                break;
        }

        /* Array preenchido conforme o grid da tab de visualização.
         * Deve ser possuir os mesmos nomes dos campos da tab.*/
        $result = array(
            "EVENTO" => $nmEvento . " - " . $dsEvento,
            "CONTRIBUINTE" => $this->Mask("##.###.###/####-##", $item['NRINSCRICAO']),
            "IDENTIFICADOR" => $id,
            "DADOS" => $dados,
        );

        return $result;
    }

    private function Mask($mask,$str){
        $str = str_replace(" ","",$str);

        for($i=0;$i<strlen($str);$i++){
            $mask[strpos($mask,"#")] = $str[$i];
        }

        return $mask;
    }


} // END class PreVisualizacao