const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
const protractorHelper = require('protractor-helper');
const j = require('../../../../json/leitorJsonHela.po.js');
const lancamentoCompraPage = require('../../../../page-objects/documentosfiscais/entradas/lancamentos/lancamentoCompra.po.js');

const gridLancamentoEntrada = '16725510123916396093497'

describe('Lançamento de entrada em digitação', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'), j.getValor('url'));
        lancamentoCompraPage.abrir();
        lancamentoCompraPage.filtroLancamentoCompra(j.getValor('filialCompra'), j.getValor('remetenteCompra'), j.getValor('dataInicialCompra'), j.getValor('dataFinalCompra'));
        geral.clickAplicarFiltro();
    });
    
    afterAll(() => {
        geral.sair();
    });
    
    it('Acessar tela de Lançamento de Entrada', () => {
        geral.esperarLoading();
        
        expect(z.component.header.getTitle())
        .toBe('Lançamento de Entrada');
    });
    
    it('Adicionar nota fiscal em digitação', () => {
        // var novoNumeroNF = lancamentoCompraPage.novoNumeroNF();
        geral.clickAdicionar();
        lancamentoCompraPage.digitarNotaFiscal(j.getValor('operacaoCompra'), j.getValor('modeloDocumento'),
                                               j.getValor('remetenteCompra'), j.getValor('serieCompra'),
                                               j.getValor('numeroCompra'), j.getValor('totalNFCompra'));
       geral.clickSalvar();
    

       expect(geral.getFieldValue('NMFILIAL'))
           .toEqual(j.getValor('filialCompra'));
       expect(geral.getFieldValue('NMRAZSOCFORN'))
           .toEqual(j.getValor('remetenteCompra'));
       expect(geral.getFieldValue('VRNOTAFISC'))
           .toEqual(j.getValor('totalNFCompra'));       
    });

    it('Lançamento do produto', () => {
        geral.trocarAba('Produtos');
        geral.clickAdicionar();
        lancamentoCompraPage.lancamentoProduto(j.getValor('produtoCompra'), j.getValor('quantidadeCompra'), j.getValor('valorUnitCompra'));
        geral.clickSalvar();
        geral.esperarLoading();

        expect(geral.getFieldValue('NMPRODUTO'))
           .toEqual(j.getValor('produtoCompra'));
        expect(geral.getFieldValue('QTITEMPROD'))
           .toEqual(j.getValor('quantidadeCompra'));
        expect(geral.getFieldValue('VRUNITITEM'))
           .toEqual(j.getValor('valorUnitCompra'));

        geral.clickFecharNF();
        geral.clickSim();

        var status = z.widget.grid.getText(gridLancamentoEntrada, 0, 0, false);
        status.getText().then(function (status) {
            expect(status).toEqual('Pendente');
        });

        
    });
});